import{s as it,o as st,n as ot}from"../chunks/scheduler.25b97de1.js";import{S as rt,i as lt,g as h,s as i,r as P,A as ht,h as u,f as a,c as s,j as et,u as Q,x as c,k as at,y as ut,a as n,v as A,d as G,t as E,w as L}from"../chunks/index.d9030fc9.js";import{T as nt}from"../chunks/Tip.baa67368.js";import{H as dt,E as mt}from"../chunks/EditOnGithub.91d95064.js";function ft(C){let d,f='Interested in adding a new quantization method to Transformers? Read the <a href="./contribute">HfQuantizer</a> guide to learn how!';return{c(){d=h("p"),d.innerHTML=f},l(o){d=u(o,"P",{"data-svelte-h":!0}),c(d)!=="svelte-1pyiy01"&&(d.innerHTML=f)},m(o,r){n(o,d,r)},p:ot,d(o){o&&a(d)}}}function pt(C){let d,f="If you are new to the quantization field, we recommend you to check out these beginner-friendly courses about quantization in collaboration with DeepLearning.AI:",o,r,p='<li><a href="https://www.deeplearning.ai/short-courses/quantization-fundamentals-with-hugging-face/" rel="nofollow">Quantization Fundamentals with Hugging Face</a></li> <li><a href="https://www.deeplearning.ai/short-courses/quantization-in-depth/" rel="nofollow">Quantization in Depth</a></li>';return{c(){d=h("p"),d.textContent=f,o=i(),r=h("ul"),r.innerHTML=p},l(l){d=u(l,"P",{"data-svelte-h":!0}),c(d)!=="svelte-lvs4zq"&&(d.textContent=f),o=s(l),r=u(l,"UL",{"data-svelte-h":!0}),c(r)!=="svelte-tsydsg"&&(r.innerHTML=p)},m(l,m){n(l,d,m),n(l,o,m),n(l,r,m)},p:ot,d(l){l&&(a(d),a(o),a(r))}}}function ct(C){let d,f,o,r,p,l,m,V="Quantization techniques focus on representing data with less information while also trying to not lose too much accuracy. This often means converting a data type to represent the same information with fewer bits. For example, if your model weights are stored as 32-bit floating points and they’re quantized to 16-bit floating points, this halves the model size which makes it easier to store and reduces memory-usage. Lower precision can also speedup inference because it takes less time to perform calculations with fewer bits.",M,g,U,w,H,b,F,$,X="The community has developed many quantization methods for various use cases. With Transformers, you can run any of these integrated methods depending on your use case because each method has their own pros and cons.",k,q,j="For example, some quantization methods require calibrating the model with a dataset for more accurate and “extreme” compression (up to 1-2 bits quantization), while other methods work out of the box with on-the-fly quantization.",S,y,B="Another parameter to consider is compatibility with your target device. Do you want to quantize on a CPU, GPU, or Apple silicon?",D,v,J="In short, supporting a wide range of quantization methods allows you to pick the best quantization method for your specific use case.",W,x,K="Use the table below to help you decide which quantization method to use.",I,_,Y='<thead><tr><th>Quantization method</th> <th>On the fly quantization</th> <th>CPU</th> <th>CUDA GPU</th> <th>RoCm GPU (AMD)</th> <th>Metal (Apple Silicon)</th> <th>torch.compile() support</th> <th>Number of bits</th> <th>Supports fine-tuning (through PEFT)</th> <th>Serializable with 🤗 transformers</th> <th>🤗 transformers support</th> <th>Link to library</th></tr></thead> <tbody><tr><td><a href="./aqlm">AQLM</a></td> <td>🔴</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>?</td> <td>1 / 2</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/Vahe1994/AQLM" rel="nofollow">https://github.com/Vahe1994/AQLM</a></td></tr> <tr><td><a href="./awq">AWQ</a></td> <td>🔴</td> <td>🔴</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>?</td> <td>4</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/casper-hansen/AutoAWQ" rel="nofollow">https://github.com/casper-hansen/AutoAWQ</a></td></tr> <tr><td><a href="./bitsandbytes">bitsandbytes</a></td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>🔴</td> <td>4 / 8</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/TimDettmers/bitsandbytes" rel="nofollow">https://github.com/TimDettmers/bitsandbytes</a></td></tr> <tr><td><a href="./eetq">EETQ</a></td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>?</td> <td>8</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/NetEase-FuXi/EETQ" rel="nofollow">https://github.com/NetEase-FuXi/EETQ</a></td></tr> <tr><td>GGUF / GGML (llama.cpp)</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td>🔴</td> <td>1 - 8</td> <td>🔴</td> <td><a href="../gguf">See GGUF section</a></td> <td><a href="../gguf">See GGUF section</a></td> <td><a href="https://github.com/ggerganov/llama.cpp" rel="nofollow">https://github.com/ggerganov/llama.cpp</a></td></tr> <tr><td><a href="./gptq">GPTQ</a></td> <td>🔴</td> <td>🔴</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>4 / 8</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/AutoGPTQ/AutoGPTQ" rel="nofollow">https://github.com/AutoGPTQ/AutoGPTQ</a></td></tr> <tr><td><a href="./hqq">HQQ</a></td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>🟢</td> <td>1 - 8</td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td><a href="https://github.com/mobiusml/hqq/" rel="nofollow">https://github.com/mobiusml/hqq/</a></td></tr> <tr><td><a href="./quanto">Quanto</a></td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td>🟢</td> <td>2 / 4 / 8</td> <td>🔴</td> <td>🔴</td> <td>🟢</td> <td><a href="https://github.com/huggingface/quanto" rel="nofollow">https://github.com/huggingface/quanto</a></td></tr></tbody>',N,z,R,T,O;return p=new dt({props:{title:"Quantization",local:"quantization",headingTag:"h1"}}),g=new nt({props:{$$slots:{default:[ft]},$$scope:{ctx:C}}}),w=new nt({props:{$$slots:{default:[pt]},$$scope:{ctx:C}}}),b=new dt({props:{title:"When to use what?",local:"when-to-use-what",headingTag:"h2"}}),z=new mt({props:{source:"https://github.com/huggingface/transformers/blob/main/docs/source/en/quantization/overview.md"}}),{c(){d=h("meta"),f=i(),o=h("p"),r=i(),P(p.$$.fragment),l=i(),m=h("p"),m.textContent=V,M=i(),P(g.$$.fragment),U=i(),P(w.$$.fragment),H=i(),P(b.$$.fragment),F=i(),$=h("p"),$.textContent=X,k=i(),q=h("p"),q.textContent=j,S=i(),y=h("p"),y.textContent=B,D=i(),v=h("p"),v.textContent=J,W=i(),x=h("p"),x.textContent=K,I=i(),_=h("table"),_.innerHTML=Y,N=i(),P(z.$$.fragment),R=i(),T=h("p"),this.h()},l(t){const e=ht("svelte-u9bgzb",document.head);d=u(e,"META",{name:!0,content:!0}),e.forEach(a),f=s(t),o=u(t,"P",{}),et(o).forEach(a),r=s(t),Q(p.$$.fragment,t),l=s(t),m=u(t,"P",{"data-svelte-h":!0}),c(m)!=="svelte-1euzkei"&&(m.textContent=V),M=s(t),Q(g.$$.fragment,t),U=s(t),Q(w.$$.fragment,t),H=s(t),Q(b.$$.fragment,t),F=s(t),$=u(t,"P",{"data-svelte-h":!0}),c($)!=="svelte-1dyd2u2"&&($.textContent=X),k=s(t),q=u(t,"P",{"data-svelte-h":!0}),c(q)!=="svelte-7cfitr"&&(q.textContent=j),S=s(t),y=u(t,"P",{"data-svelte-h":!0}),c(y)!=="svelte-o9oe2x"&&(y.textContent=B),D=s(t),v=u(t,"P",{"data-svelte-h":!0}),c(v)!=="svelte-1xmraw"&&(v.textContent=J),W=s(t),x=u(t,"P",{"data-svelte-h":!0}),c(x)!=="svelte-1nfyben"&&(x.textContent=K),I=s(t),_=u(t,"TABLE",{"data-svelte-h":!0}),c(_)!=="svelte-15fu8fb"&&(_.innerHTML=Y),N=s(t),Q(z.$$.fragment,t),R=s(t),T=u(t,"P",{}),et(T).forEach(a),this.h()},h(){at(d,"name","hf:doc:metadata"),at(d,"content",gt)},m(t,e){ut(document.head,d),n(t,f,e),n(t,o,e),n(t,r,e),A(p,t,e),n(t,l,e),n(t,m,e),n(t,M,e),A(g,t,e),n(t,U,e),A(w,t,e),n(t,H,e),A(b,t,e),n(t,F,e),n(t,$,e),n(t,k,e),n(t,q,e),n(t,S,e),n(t,y,e),n(t,D,e),n(t,v,e),n(t,W,e),n(t,x,e),n(t,I,e),n(t,_,e),n(t,N,e),A(z,t,e),n(t,R,e),n(t,T,e),O=!0},p(t,[e]){const Z={};e&2&&(Z.$$scope={dirty:e,ctx:t}),g.$set(Z);const tt={};e&2&&(tt.$$scope={dirty:e,ctx:t}),w.$set(tt)},i(t){O||(G(p.$$.fragment,t),G(g.$$.fragment,t),G(w.$$.fragment,t),G(b.$$.fragment,t),G(z.$$.fragment,t),O=!0)},o(t){E(p.$$.fragment,t),E(g.$$.fragment,t),E(w.$$.fragment,t),E(b.$$.fragment,t),E(z.$$.fragment,t),O=!1},d(t){t&&(a(f),a(o),a(r),a(l),a(m),a(M),a(U),a(H),a(F),a($),a(k),a(q),a(S),a(y),a(D),a(v),a(W),a(x),a(I),a(_),a(N),a(R),a(T)),a(d),L(p,t),L(g,t),L(w,t),L(b,t),L(z,t)}}}const gt='{"title":"Quantization","local":"quantization","sections":[{"title":"When to use what?","local":"when-to-use-what","sections":[],"depth":2}],"depth":1}';function wt(C){return st(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class vt extends rt{constructor(d){super(),lt(this,d,wt,ct,it,{})}}export{vt as component};
